//@author: antokhio
//@help: template for geometry shaders
//@tags: GS, template
//@credits:

float4x4 tW : WORLD;
float4x4 tVP : VIEWPROJECTION;

struct VS_IN
{
	float4 pos : POSITION;
	float4 uv : TEXCOORD0;
};

struct VS_OUT
{
	float4 pos : POSITION;
	float4 uv : TEXCOORD0;
};

struct GS_OUT
{
	float4 pos : SV_Position;
	float4 uv : TEXCOORD0;
	uint vp : SV_ViewportArrayIndex;
	//uint vp : VIEWPORTINDEX ;
};

VS_OUT VS(VS_IN input)
{
    return input;
}

uint vi;
[maxvertexcount(3)]
void GS(triangle VS_OUT input[3], inout TriangleStream<GS_OUT> gsout)
{
	GS_OUT output;
	
	for (int i = 0 ; i < 3 ; i ++)
	{
		output.pos = mul (input[i].pos, mul (tW, tVP));
		output.uv = input[i].uv;
		output.vp = vi;
		gsout.Append(output);
	}
	gsout.RestartStrip();
}

float4 PS(GS_OUT input): SV_Target
{
    return 1;
}

technique10 Template
{
    pass P0
    {
        SetVertexShader( CompileShader( vs_4_0, VS() ) );
        SetGeometryShader( CompileShader( gs_4_0, GS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
    }  
}